LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;
USE work.my_package.all;

---------------------------------------------------
-- MY FIR filter
-- Computation of the coefficients
-- Version 3.0
-- 11 coefficients
-- Use of multiplication character "*"
-- Author: Vebjrn Bystrm, NTNU 14.may 2008
---------------------------------------------------

PACKAGE my_functions is 

FUNCTION coeff_0 (signal c: in std_logic_vector) 
RETURN std_logic_vector;
FUNCTION coeff_1 (signal c : std_logic_vector) 
RETURN std_logic_vector;
FUNCTION coeff_2 (signal c : std_logic_vector) 
RETURN std_logic_vector;
FUNCTION coeff_3 (signal c : std_logic_vector) 
RETURN std_logic_vector;
FUNCTION coeff_4 (signal c : std_logic_vector) 
RETURN std_logic_vector;
FUNCTION coeff_5 (signal c : std_logic_vector) 
RETURN std_logic_vector;
FUNCTION coeff_6 (signal c : std_logic_vector) 
RETURN std_logic_vector;
FUNCTION coeff_7 (signal c : std_logic_vector) 
RETURN std_logic_vector;
FUNCTION coeff_8 (signal c : std_logic_vector) 
RETURN std_logic_vector;
FUNCTION coeff_9 (signal c : std_logic_vector) 
RETURN std_logic_vector;
FUNCTION coeff_10 (signal c : std_logic_vector) 
RETURN std_logic_vector;

END my_functions;

PACKAGE BODY my_functions is 


--------------  COEFF_0 ----------------------------
	FUNCTION coeff_0 (signal c: in std_logic_vector) 
	RETURN std_logic_vector IS
		
		VARIABLE temp : std_logic_vector (23 DOWNTO 0);
				
			
	BEGIN
		temp := c * "0000000000011000";
		
		
		return temp;
	END coeff_0;
----------------------------------------------------

--------------  COEFF_1 ----------------------------	
	FUNCTION coeff_1 (signal c: in std_logic_vector) 
	RETURN std_logic_vector IS
		
		VARIABLE temp : std_logic_vector (23 DOWNTO 0);
				
			
	BEGIN
		temp := c * "0000000010001001";
		
		
		return temp;
				
	END coeff_1;
----------------------------------------------------

--------------  COEFF_2 ----------------------------
	FUNCTION coeff_2 (signal c: in std_logic_vector) 
	RETURN std_logic_vector IS
				
		VARIABLE temp : std_logic_vector (23 DOWNTO 0);
				
			
	BEGIN
		temp := c * "1111111001000101";
		
		
		return temp;
				
	END coeff_2;
----------------------------------------------------

--------------  COEFF_3 ----------------------------
	FUNCTION coeff_3 (signal c: in std_logic_vector) 
	RETURN std_logic_vector IS
		
		VARIABLE temp : std_logic_vector (23 DOWNTO 0);
				
			
	BEGIN
		temp := c * "1111111001000100";
		
		
		return temp;
	
	END coeff_3;
----------------------------------------------------
	

--------------  COEFF_4 ----------------------------
	FUNCTION coeff_4 (signal c: in std_logic_vector) 
	RETURN std_logic_vector IS
		
		VARIABLE temp : std_logic_vector (23 DOWNTO 0);
				
			
	BEGIN
		temp := c * "0000101101010010";
		
		
		return temp;
	
	END coeff_4;
----------------------------------------------------

--------------  COEFF_5 ----------------------------
	FUNCTION coeff_5 (signal c: in std_logic_vector) 
	RETURN std_logic_vector IS
		
		VARIABLE temp : std_logic_vector (23 DOWNTO 0);
				
			
	BEGIN
		temp := c * "0001010111001000";
		
		
		return temp;
	
	END coeff_5;
----------------------------------------------------

--------------  COEFF_6 ----------------------------
	FUNCTION coeff_6 (signal c: in std_logic_vector) 
	RETURN std_logic_vector IS
		
		VARIABLE temp : std_logic_vector (23 DOWNTO 0);
				
			
	BEGIN
		temp := c * "0000101101010010";
		
		
		return temp;
	
	END coeff_6;
----------------------------------------------------

--------------  COEFF_7 ----------------------------
	FUNCTION coeff_7 (signal c: in std_logic_vector) 
	RETURN std_logic_vector IS
		
		VARIABLE temp : std_logic_vector (23 DOWNTO 0);
				
			
	BEGIN
		temp := c * "1111111001000100";
		
		
		return temp;
	
	END coeff_7;
----------------------------------------------------


--------------  COEFF_8 ----------------------------
	FUNCTION coeff_8 (signal c: in std_logic_vector) 
	RETURN std_logic_vector IS
		
		VARIABLE temp : std_logic_vector (23 DOWNTO 0);
				
			
	BEGIN
		temp := c * "1111111001000101";
		
		
		return temp;
	
	END coeff_8;
----------------------------------------------------

--------------  COEFF_9 ----------------------------
	FUNCTION coeff_9 (signal c: in std_logic_vector) 
	RETURN std_logic_vector IS
		
		VARIABLE temp : std_logic_vector (23 DOWNTO 0);
				
			
	BEGIN
		temp := c * "0000000010001001";
		
		
		return temp;
	
	END coeff_9;
----------------------------------------------------

--------------  COEFF_10 ---------------------------
	FUNCTION coeff_10 (signal c: in std_logic_vector) 
	RETURN std_logic_vector IS
		
		VARIABLE temp : std_logic_vector (23 DOWNTO 0);
				
			
	BEGIN
		temp := c * "0000000000011000";
		
		
		return temp;
	
	END coeff_10;
----------------------------------------------------


END my_functions;